log4js = require 'log4js'
logger = log4js.getLogger 'BaseInterface'

EventEmitter = require 'events'

class InterfaceEmitter extends EventEmitter

class BaseInterface
  constructor: () ->
    @emitter = new InterfaceEmitter

BaseInterface::request = (request, payload) ->
  logger.warn 'must be overloaded'
  Promise.resolve payload

# Returns promise. Callback with message.
BaseInterface::subscribe = (channel, callback) ->
  logger.warn 'must be overloaded'
  Promise.resolve()

BaseInterface::publish = (channel, data) ->
  logger.warn 'must be overloaded'
  Promise.resolve()

BaseInterface.InterfaceEmitter = InterfaceEmitter

module.exports = BaseInterface